//
//  ckTZDrawView.m
//  CKs Time Zone Picker
//
//  Created by C.K. Haun on 3/27/14.
//  Copyright (c) 2014 Ravenware Industries LLC. All rights reserved.
//

#import "ckTZDrawView.h"

@implementation ckTZDrawView
@synthesize element;

// drawing.  Yes, this gets ugly fast, I found this out when
// I dove into it.  Obvioulsy, some of this could be factored into other methods, but one big
// blob is good for this example
- (void)drawRect:(CGRect)rect
{
    // Yes I'm doing CG drawing, I just like it better
    CGContextRef 	cG = UIGraphicsGetCurrentContext();
    NSDate *dateTime ;
    CGPoint textHere;
    // change this if you need another locale format.  NSLocale class reference
    NSLocale *twelveHourLocale = [[NSLocale alloc] initWithLocaleIdentifier:@"en_US_POSIX"];
    NSString *dateInStringFormatedRight;
    CGRect drawingRect = [self bounds];
    NSString *formatMins12 = @"hh:mm a";
    UIFont *textFont = [UIFont systemFontOfSize:18];
    NSString *zoone;
    int tzNameFormat;

    // simple drawing
    CGContextSetStrokeColorWithColor(cG, [[UIColor blackColor] CGColor] );
    textHere = CGPointMake(drawingRect.origin.x+10, drawingRect.origin.y+30);
    
    // the Date formatter sets how the time string will be returned.
    // we're wanting just the hours and minutes, in AM/PM format
    // many other string formats can be returned, check the NSDateFormatter class docs
    if(dateFormatter == nil)
        dateFormatter = [[NSDateFormatter alloc] init];
    
    [dateFormatter setDateFormat:formatMins12];
    // If I made this time zone up it doesn't have a "real" name, so
    // create  a time zone based on offset from UTC
    if(element.synthesized)
        timeZone = [NSTimeZone timeZoneForSecondsFromGMT:element.offsetFromUTC * 60 * 60];
    else
        timeZone = [NSTimeZone timeZoneWithName: element.completeName];
    [dateFormatter setTimeZone:timeZone];
    
    // now get the current time
    dateTime=[NSDate dateWithTimeIntervalSinceNow:(60*60)];
    // and pull the time string out in the format we want
    dateInStringFormatedRight = [dateFormatter stringFromDate:dateTime];

    // draw it
    [dateInStringFormatedRight drawAtPoint:textHere withAttributes:@{NSFontAttributeName: textFont}];
    
    // Now draw the time zone name.  Again, if I made it up I also made up the name
    if(element.synthesized){
        zoone = element.city;
    }else {
        // Check for daylight savings time
        BOOL dst = [timeZone    isDaylightSavingTimeForDate:dateTime];
        // and ask for the Daylihgt name if it's that time of year.
        if(dst)
            tzNameFormat = NSTimeZoneNameStyleDaylightSaving;
        else
            tzNameFormat = NSTimeZoneNameStyleStandard;
        zoone = [timeZone localizedName:tzNameFormat locale:twelveHourLocale];
    }
    //  The OS still says GMT, that's archaic.  Set it to UTC
    if([zoone isEqualToString:@"GMT"])
        zoone = @"UTC";
    
    
    // and draw it
    textHere.y +=22;
    [zoone drawAtPoint:textHere withAttributes:@{NSFontAttributeName: textFont}];

}

@end
