//
//  ckTZViewController.m
//  CKs Time Zone Picker
//
//  Created by C.K. Haun on 3/27/14.
//  Copyright (c) 2014 Ravenware Industries LLC. All rights reserved.
//

#import "ckTZViewController.h"

@interface ckTZViewController ()
-(void)secondTick:(NSTimer *)theTimer;

@end

@implementation ckTZViewController
@synthesize tzPicker,timeDrawView;
- (void)viewDidLoad
{
    [super viewDidLoad];
    theZones =  [[ckTimeZoneListBundle alloc]init];
    // set up a timer to update the clock every few seconds.  I'm using 5 seconds because I don't need
    // much precision here and I hate wasting cycles.
        secondsTimer = [NSTimer scheduledTimerWithTimeInterval: 5.0 target:self selector:@selector(secondTick:) userInfo:nil repeats: YES];
    
    ckTimeZoneListElement * startingElement = [theZones  getElementForNSTimeZone:[NSTimeZone systemTimeZone]];
    timeDrawView.element = startingElement;
    [tzPicker setZoneValueByElement:startingElement];
    [self registerAsObserver ];

}

-(void)secondTick:(NSTimer *)theTimer{
    [timeDrawView setNeedsDisplay];
}

// we are going to watch the element that the UIPickerController currently has
// selected.  When it changes, we will alert the clock view
- (void)registerAsObserver {

    [tzPicker addObserver:self
              forKeyPath:@"currentElement"
                 options:(NSKeyValueObservingOptionNew| NSKeyValueObservingOptionOld
                          )
                 context:NULL];
}
// time zone changed.  Pass it to the clock and have the clock redraw.
- (void)observeValueForKeyPath:(NSString *)keyPath
                      ofObject:(id)object
                        change:(NSDictionary *)change
                       context:(void *)context{
    timeDrawView.element = [change objectForKey:NSKeyValueChangeNewKey];
    [timeDrawView setNeedsDisplay];
}

@end
