//
//  ckTimeZoneListBundle.h
//  CKs Time Zone Picker
//
//  Created by C.K. Haun on 3/27/14.
//  Copyright (c) 2014 Ravenware Industries LLC. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ckTimeZoneListElement.h"

@interface ckTimeZoneListCluster : NSObject{
    NSString *header;
    NSMutableArray *elements;
}
@property (nonatomic, retain) NSString *header;
@property (nonatomic, retain) NSMutableArray *elements;



-(BOOL)mergeIntoCluster:(ckTimeZoneListElement *)element;
-(NSInteger) elementInCluster:(ckTimeZoneListElement*)element;
- (void)encodeWithCoder:(NSCoder *)encoder;
- (id)initWithCoder:(NSCoder *)decoder;


@end

@interface ckTimeZoneListBundle : NSObject{
    NSMutableArray *clusters;
    NSMutableArray *elements;
}
@property (nonatomic, retain) NSArray *clusters;
@property (nonatomic, retain) NSMutableArray *elements;

-(id)init;
- (void)encodeWithCoder:(NSCoder *)encoder;
- (id)initWithCoder:(NSCoder *)decoder;


-(NSInteger)inWhichCluster:(ckTimeZoneListElement *)element;
-(ckTimeZoneListElement *)getElementForNSTimeZone:(NSTimeZone *)theZone;
-(ckTimeZoneListElement *)getElementForTimeZoneName:(NSString *)theZone;



@end