//
//  ckTimeZoneListElement.h
//  CKs Time Zone Picker
//
//  Created by C.K. Haun on 3/27/14.
//  Copyright (c) 2014 Ravenware Industries LLC. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface ckTimeZoneListElement : NSObject{
    BOOL synthesized;                   // is this a made-up element
    NSInteger indexInFullArray;      // where this is in the System master list
    NSString *completeName;        // '/' delimited name
    NSString *prefix;                      // major area
    NSString *city;                         // city
    NSArray *components;            // components broken down
    NSInteger offsetFromUTC;                 // hours offset from UTC
}
@property (nonatomic,assign)    BOOL synthesized;
@property (nonatomic, assign) NSInteger indexInFullArray;
@property (nonatomic, retain) NSString *completeName;
@property (nonatomic, retain) NSString *prefix;
@property (nonatomic, retain) NSString *city;
@property (nonatomic, retain) NSArray *components;
@property (nonatomic,assign)     NSInteger offsetFromUTC;

-(id)initWithName:(NSString *) name andIndex:(int)index;

- (void)encodeWithCoder:(NSCoder *)encoder;
- (id)initWithCoder:(NSCoder *)decoder;
-(id)initAndSythesizeElement:(NSString *)newPrefix newName:(NSString *)theName offsetFromUTC:(int)offset;
@end
