//
//  ckTimeZoneListElement.m
//  CKs Time Zone Picker
//
//  Created by C.K. Haun on 3/27/14.
//  Copyright (c) 2014 Ravenware Industries LLC. All rights reserved.
//

#import "ckTimeZoneListElement.h"

@implementation ckTimeZoneListElement
@synthesize indexInFullArray,synthesized;
@synthesize completeName;
@synthesize prefix;
@synthesize city;
@synthesize components;
@synthesize offsetFromUTC;

-(id)initWithName:(NSString *) name andIndex:(int)index{
    indexInFullArray = index;
    completeName = name;
    // time zone names are provided by the system in '/' seperated strings, like "Africa/Abidjan"
    // we'll break them apart so we can feed the two wheels of the picker seperately
    components= [ name componentsSeparatedByString:@"/"];
    NSUInteger arrayCount = [components count];
                prefix = [components objectAtIndex:0];
            if(arrayCount>2){
                // there are some times that have a double major area, so we
                // concatinate the first two, like in the "america/argentina" case
                int ww=1;
                do{
                    prefix =[prefix stringByAppendingString:@"/"];
                    prefix = [prefix stringByAppendingString:[components objectAtIndex:ww]];
                    ww++;
                }while (ww<arrayCount-1);
            }
    // and pull the city name from the end
    city =   [components objectAtIndex:arrayCount-1];            

    
    
    
    return (self);
}

// this allows us to create our own time zone.  I use this for the US Standard zones
// look at the ckTimeZoneListCluster init method for why I do that.
-(id)initAndSythesizeElement:(NSString *)newPrefix newName:(NSString *)theName offsetFromUTC:(int)offset{
    NSString *full;
    full = [newPrefix stringByAppendingString:@"/"];
    full = [full stringByAppendingString:theName];
    completeName = full;
    prefix = newPrefix;
    city = theName;
    offsetFromUTC = offset;
    synthesized = YES;
    components = [[NSArray alloc]initWithObjects:newPrefix,theName, nil];
    return (self);
}
// archive and unarchive
- (void)encodeWithCoder:(NSCoder *)encoder 
{
    [encoder encodeBool:synthesized forKey:@"synthesized"];
    [encoder encodeInteger:self.indexInFullArray forKey:@"indexInFullArray"];
    [encoder encodeObject:self.completeName forKey:@"completeName"];
    [encoder encodeObject:self.prefix forKey:@"prefix"];
    [encoder encodeObject:self.city forKey:@"city"];
    [encoder encodeObject:self.components forKey:@"components"];
    [encoder encodeInteger:offsetFromUTC forKey:@"UTCOffset"];

}

- (id)initWithCoder:(NSCoder *)decoder 
{
    self = [super init];
    if (self) {
        self.synthesized = [decoder decodeBoolForKey:@"synthesized"];
        self.indexInFullArray = [decoder decodeIntegerForKey:@"indexInFullArray"];
        self.completeName = [decoder decodeObjectForKey:@"completeName"];
        self.prefix = [decoder decodeObjectForKey:@"prefix"];
        self.city = [decoder decodeObjectForKey:@"city"];
        self.components = [decoder decodeObjectForKey:@"components"];
        self.offsetFromUTC = [decoder decodeIntegerForKey:@"UTCOffset"];
    }
    return self;
}


@end
